#!/nfs/public/bin/sybperl
#
# Program:  helpdesk1.pl      Description:  Parses out data from helpdesk.pl
#                                           and inserts info. into the database
#                                           and sends email to user and support
#
# This is part of the Helpdesk Management System written by Mark Mellman.
#
# Date last revision: 08/16/96   Version: 2.00

require "helpdesk.inc" ;

##############################################
#  Parse info from helpdesk.pl
##############################################

$buffer=<STDIN>;
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value=~ tr/+/ /;
  $value=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
}

$FORM{"requestDescription"}=~ tr/\"/ /;
$FORM{"requestDescription"}=~ tr/\'/ /;
$empid=$FORM{"employee"};
$deptid=$FORM{"department"};
$probtype=$FORM{"problemType"};
$dtneed=$FORM{"dateNeededBy"};
$prio=$FORM{"priority"};
$wvar=$FORM{"requestDescription"};
if(length($wvar) > 254) {
  $req=substr($wvar, 0, 255);
  $req1=substr($wvar, 255, 255);
} else {
  $req=$wvar;
  $req1=" ";
}

##################################################################
#  Test to make sure there is an employee id before continuing
##################################################################

if( $empid < 1) {
  print "Content-type: text/html\n\n";
  printf "
<title>Ticket Submitted Unsuccessfully Screen</title>
<h1><center>Ticket was not successful.</center></h1>
<body bgcolor=\"FFFFFF\" text=\"#000000\" link=\"#CC0000\" alink=\"#FF3300\" vlink=\"#330099\">
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<center>Press the \"BACK\" button on top and select your name from the employee list</center>
</body>
</html>
";
  exit;
}
##################################################################
# Get data from other tables to complete master record insert
##################################################################

&emp_login;
&get_emp;
&get_dept;  
$status="U";

##################################################################
#  Insert master record (OTicket)
##################################################################

&helpdesk_login;
$str=  "insert OTicket " ;
$str = $str . "values (getdate(), \"$dtneed\", \"$status\", \"$dept\", \"$probtype\", ";
$str = $str . "\"$req\", ";
$str = $str . "\"$req1\", ";
$str = $str . "\"$fname\", \"$lname\", \"$prio\", \" \", \"$email\", 0, 0, $empid) " ;
&do_isql;

##################################################################
#  Get the ticket number that was just added
##################################################################

$str="select @@identity";
&dbcmd($dbproc, $str);
&dbresults($dbproc);
&dbsqlexec ($dbproc);
if(&dbresults($dbproc)==&SUCCEED) {
  @data=&dbnextrow($dbproc);
}
$ticket=$data[0];
&do_mail;
&do_submitted;

######################################################################
#  Send sumitter and support personnel group email with ticket info
######################################################################

sub do_mail {
  open (NEWREQ, "| /usr/bin/mail $SUPPORTGRP, $email");
  printf NEWREQ "From: %s
subject: Request number %d
  
Problem Description:

%s %s

Date Needed by:  %s           Priority:  %s", $email, $data[0], $req, $req1, $dtneed, $prio;
  close(NEWREQ); 
}

######################################################################
#  Display ticket info back to user and have them acknowledge
######################################################################

sub do_submitted {
  print "Content-type: text/html\n\n";
  printf "
<title>Ticket Submitted Successfully Screen</title>
<h1><center>Ticket number %d Submitted.</center></h1>
<body bgcolor=\"FFFFFF\" text=\"#000000\" link=\"#CC0000\" alink=\"#FF3300\" vlink=\"#330099\">
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<center>\*NOTE:  A notification has been mailed to the Systems group.</center>
<br>
<br>
<br>
<center>
<h3><a href=\"../../systems/index.html\">
RECORDED</h3>
</center></a>
</body>
</html>", $ticket;
}

######################################################################
#  Get submitter information for the person creating ticket
######################################################################

sub get_emp
{
  $emp_str = "select lastName, altName, email ";
  $emp_str = $emp_str . "from MPerson where personId = $empid";
  &dbcmd ( $dbproc, $emp_str ) ;
  &dbsqlexec ($dbproc);
  &dbresults($dbproc) ;
  @data = &dbnextrow($dbproc);
  $lname =  $data[0] ;
  $fname =  $data[1];
  $email = $data[2];
}

######################################################################
#  Get department information by using the association table
######################################################################

sub get_dept
{
  $dep_str = "select departmentId from DepartmentPeople ";
  $dep_str = $dep_str . "where personId = $empid and termDate = NULL";
  &dbcmd ( $dbproc, $dep_str ) ;
  &dbsqlexec ($dbproc);
  &dbresults($dbproc) ;
  @data = &dbnextrow($dbproc);
  $deptid =  $data[0] ;
  $dep_str = "select departmentId, deptName ";
  $dep_str = $dep_str . "from Department where departmentId = $deptid";
  &dbcmd ( $dbproc, $dep_str ) ;
  &dbsqlexec ($dbproc);
  &dbresults($dbproc) ;
  @data = &dbnextrow($dbproc);
  $deptId =  $data[0] ;
  $dept =  $data[1];
}

#########################################################
#  Perform the SQL query
#########################################################

sub do_isql
{
  &dbcmd ( $dbproc, $str ) ;
  if ( &dbsqlexec ($dbproc) != &SUCCEED )
  {
    print "Error executing command\n" ;
  }

  &dbresults($dbproc);
}

